package explorviz.live_trace_processing.filter.reduction.language_based;

import java.util.ArrayList;
import java.util.List;

import explorviz.live_trace_processing.filter.IPipeReceiver;
import explorviz.live_trace_processing.record.event.AbstractBeforeEventRecord;
import explorviz.live_trace_processing.record.event.AbstractEventRecord;
import explorviz.live_trace_processing.record.event.constructor.AfterConstructorEventRecord;
import explorviz.live_trace_processing.record.event.constructor.BeforeConstructorEventRecord;
import explorviz.live_trace_processing.record.trace.Trace;

public class RemoveConstructorsFilter extends AbstractLanguageBasedFilter {

	public RemoveConstructorsFilter(final IPipeReceiver receiver) {
		super(receiver, "ConstructorHiding");
	}

	@Override
	protected Trace reduceTrace(final Trace trace) {
		final List<AbstractEventRecord> traceEvents = new ArrayList<AbstractEventRecord>();
		for (final AbstractEventRecord event : trace.getTraceEvents()) {
			if (event instanceof BeforeConstructorEventRecord) {

			} else if (event instanceof AfterConstructorEventRecord) {

			} else {
				traceEvents.add(event);
			}
		}
		return new Trace(traceEvents, true);
	}

	@Override
	protected boolean isSoughtEvent(final AbstractBeforeEventRecord abstractBeforeEventRecord) {
		// not used
		return false;
	}

}
